# Generated by Django 4.1.7 on 2023-05-29 11:49

import django.db.models.deletion
from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ("documents", "0003_initial"),
        ("training", "0001_initial"),
        ("ponos", "0001_initial"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.AddField(
            model_name="dataset",
            name="creator",
            field=models.ForeignKey(on_delete=django.db.models.deletion.DO_NOTHING, related_name="datasets", to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name="dataset",
            name="elements",
            field=models.ManyToManyField(related_name="datasets", through="training.DatasetElement", to="documents.element"),
        ),
        migrations.AddField(
            model_name="dataset",
            name="task",
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name="dataset", to="ponos.task"),
        ),
        migrations.AddConstraint(
            model_name="modelversion",
            constraint=models.UniqueConstraint(fields=("model", "tag"), name="modelversion_unique_tag"),
        ),
        migrations.AddConstraint(
            model_name="modelversion",
            constraint=models.UniqueConstraint(condition=models.Q(("hash__isnull", False)), fields=("model", "hash"), name="modelversion_unique_hash"),
        ),
        migrations.AddConstraint(
            model_name="metricvalue",
            constraint=models.UniqueConstraint(condition=models.Q(("step__isnull", False)), fields=("metric", "step"), name="metric_unique_step"),
        ),
        migrations.AddConstraint(
            model_name="metricvalue",
            constraint=models.UniqueConstraint(condition=models.Q(("step__isnull", True)), fields=("metric", "created"), name="metric_unique_no_step"),
        ),
        migrations.AlterUniqueTogether(
            name="metrickey",
            unique_together={("name", "model_version")},
        ),
        migrations.AddConstraint(
            model_name="datasetelement",
            constraint=models.UniqueConstraint(fields=("dataset", "element", "set"), name="unique_dataset_elements"),
        ),
        migrations.AddConstraint(
            model_name="dataset",
            constraint=models.UniqueConstraint(fields=("corpus", "name"), name="unique_dataset_names"),
        ),
    ]
